theory Scratch2
imports Main
begin

(**************************************************)

term "let Person = [''Alice'', ''Bob'', ''Mallory''] in
      let Planet = [ Person, Person, Person ] in
      let Galaxy = [ Planet ] in
      let OclAny = [ Galaxy, Galaxy ] in
      ()"

(**************************************************)

definition "Person = [''Alice'', ''Bob'', ''Mallory'']"
definition "Planet = [ Person, Person, Person ]"
definition "Galaxy = [ Planet ]"
definition "OclAny = [ Galaxy, Galaxy ]"

(**************************************************)

datatype Person = Alice | Bob | Mallory
datatype Planet = OnePlanet Person Person Person
datatype Galaxy = OneGalaxy Planet
datatype OclAny = OneOclAny Galaxy Galaxy

(**************************************************)

lemma True
proof -

  def Person \<equiv> "[''Alice'', ''Bob'', ''Mallory'']"
  def Planet \<equiv> "[ Person, Person, Person ]"
  def Galaxy \<equiv> "[ Planet ]"
  def OclAny \<equiv> "[ Galaxy, Galaxy ]"

  show "Person = Person \<Longrightarrow> ?thesis"
  by auto
qed auto

(**************************************************)

lemma True
proof -

  let ?Person = "[''Alice'', ''Bob'', ''Mallory'']"
  let ?Planet = "[ ?Person, ?Person, ?Person ]"
  let ?Galaxy = "[ ?Planet ]"
  let ?OclAny = "[ ?Galaxy, ?Galaxy ]"

  show "?Person = ?Person \<Longrightarrow> ?thesis"
  by auto
qed auto

(**************************************************)

lemma True
proof -
  fix X

  have Person: "X = ''Alice'' \<or> X = ''Bob'' \<or> X = ''Mallory'' \<Longrightarrow> True" by auto
  note Planet = Person Person Person
  note Galaxy = Planet
  note OclAny = Galaxy Galaxy

  show ?thesis
   using Person Planet Galaxy OclAny
  by auto
qed

(**************************************************)

locale True =
 fixes Person Planet Galaxy OclAny

 defines "Person \<equiv> [''Alice'', ''Bob'', ''Mallory'']"
 defines "Planet \<equiv> [ Person, Person, Person ]"
 defines "Galaxy \<equiv> [ Planet ]"
 defines "OclAny \<equiv> [ Galaxy, Galaxy ]"

(**************************************************)


(*

\<M>\<E>\<T>\<A>_\<L>\<E>\<T>   New_Term_Command X Y =  [ term X,
                                       term X,
                                      datatype aa = BBBB Y ]


New_Term_Command ''string'' nat    (* <- this aims to generate and evaluate
                                         what is just defined above *)
*)
term "''string''"
term "''string''"
datatype aa = BBBB nat
end